#!/usr/bin/env python

# 

 # This library is free software; you can redistribute it and/or
 # modify it under the terms of the GNU Library General Public
 # License as published by the Free Software Foundation; either
 # version 2 of the License, or (at your option) any later version.
 #
 # This library is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 # Library General Public License for more details.
 #
 # You should have received a copy of the GNU Library General Public
 # License along with this library; if not, write to the
 # Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 # Boston, MA 02111-1307, USA.
#


import pygtk
pygtk.require('2.0')
import gtk
import time
class SelectArea(object):
    # Create a new backing pixmap of the appropriate size
    def __init__(self, command_line = False):
        self.pixmap = None
        self.is_drawing=False
        self.start_x=0
        self.start_y=0
        self.x=0
        self.y=0
        self.win_root_gdk = gtk.gdk.get_default_root_window()
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.rect2watch=None
        self.is_choosing = False
        if command_line:
            return
        width, height = self.win_root_gdk.get_size()    

        self.window.connect("destroy", lambda w: gtk.main_quit())

        # Create the drawing area

        self.drawing_area = gtk.DrawingArea()
        self.drawing_area.set_size_request(width, height)
 
        self.drawing_area.show()

        # Signals used to handle backing pixmap
        self.drawing_area.connect("expose_event", self.expose_event)
        self.drawing_area.connect("configure_event", self.configure_event)

        # Event signals
        self.drawing_area.connect("motion_notify_event", self.motion_notify_event)
        self.drawing_area.connect("button_press_event", self.button_press_event)
        self.drawing_area.connect("button-release-event", self.button_release_event)

        self.drawing_area.set_events(gtk.gdk.EXPOSURE_MASK
                                | gtk.gdk.LEAVE_NOTIFY_MASK
                                | gtk.gdk.BUTTON_PRESS_MASK
                                | gtk.gdk.BUTTON_RELEASE_MASK
                                | gtk.gdk.POINTER_MOTION_MASK
                                | gtk.gdk.POINTER_MOTION_HINT_MASK)

        #set cursor
        #cursor=gtk.gdk.Cursor(gtk.gdk.PENCIL)
        #self.window.get_screen().get_root_window().set_cursor(cursor)

        self.window.set_decorated(False)
        self.window.add(self.drawing_area)
        
      
        self.window.fullscreen()

        pb = gtk.gdk.Pixbuf(gtk.gdk.COLORSPACE_RGB,True,8, width, height)
        self.pbd = pb.get_from_drawable(self.win_root_gdk , self.win_root_gdk .get_colormap(), 0, 0, 0, 0, width, height)
     
        #if (self.pbd != None):
        #    self.pbd.save('screen.png', 'png')
        self.gc = gtk.gdk.GC(self.win_root_gdk)
        self.gc.set_function(gtk.gdk.COPY)
        #self.win_root_gdk.draw_pixbuf(self.gc, self.pbd, 0, 0, 0, 0, width, height)
        #self.drawing_area.queue_draw_area(0, 0, width, height)
        self.window.show()
        gtk.main()
    def configure_event(self, widget, event):
        x, y, width, height = widget.get_allocation()
        self.pixmap = gtk.gdk.Pixmap(widget.window, width, height)
        self.pixmap.draw_pixbuf(self.gc, self.pbd, 0, 0, 0, 0, width, height)
        self.orig_pixmap = self.pixmap
        widget.window.set_back_pixmap(self.pixmap, False)
        return True

    # Redraw the screen from the backing self.pixmap
    def expose_event(self, widget, event):
        x , y, width, height = event.area
        widget.window.draw_drawable(widget.get_style().fg_gc[gtk.STATE_NORMAL],
                                    self.pixmap, x, y, x, y, width, height)
        return False

    # Draw a rectangle on the screen
    def draw_brush(self, widget, start_x, start_y, x, y, style, fill=True):
        orig_rect=self.rect2watch
        rect = (min(start_x, x), min(start_y, y), max(start_x, x), max(start_y, y))
        self.rect2watch = (rect[0], rect[1], rect[2]-rect[0] +1, rect[3]-rect[1]+1)
        #restore old area from the screenshot
        #print orig_rect
        
        self.pixmap.draw_pixbuf(self.gc, self.pbd, orig_rect[0], orig_rect[1] , orig_rect[0], orig_rect[1], orig_rect[2], orig_rect[3])
        self.drawing_area.queue_draw_area(orig_rect[0], orig_rect[1], orig_rect[2], orig_rect[3])

        #draw new rectangle
        
        gc = widget.get_style().black_gc
        gc.set_function(gtk.gdk.INVERT)
        gc.set_line_attributes(1, gtk.gdk.LINE_SOLID, gtk.gdk.CAP_BUTT, gtk.gdk.JOIN_MITER)
        self.pixmap.draw_lines(gc, ((rect[0],rect[1]), (rect[0],rect[3]), (rect[2],rect[3]), (rect[2],rect[1]), (rect[0],rect[1])))
        widget.queue_draw_area(self.rect2watch[0], self.rect2watch[1], self.rect2watch[2], self.rect2watch[3])

    def fill_window(self, widget, event):
        if not self.is_drawing:
            self.start_x=int(event.x)
            self.start_y=int(event.y)
            self.x=self.start_x
            self.y=self.start_y
            sz=widget.window.get_size()
            widget.window.draw_drawable(widget.get_style().fg_gc[gtk.STATE_NORMAL],
                               self.pixmap, 0, 0, 0, 0, sz[0], sz[1])
            widget.queue_draw_area(0, 0, sz[0], sz[1])
            self.pixmap.draw_rectangle(widget.get_style().white_gc,
                          True, 0, 0, sz[0], sz[1])
            self.is_drawing=True
    
    def button_press_event(self, widget, event):
        '''Drawing rectangle. 
        When entered first time remember position'''
        if event.button == 1 and self.pixmap != None:
            #print "press_event"
            #self.fill_window(widget,event)
            self.start_x=int(event.x)
            self.start_y=int(event.y)
            self.x=self.start_x
            self.y=self.start_y
            self.rect2watch = (self.x, self.y, 1, 1)
            self.is_choosing = True
            #self.draw_brush(widget, event.x, event.y, style=widget.get_style().black_gc)
        return True

    def button_release_event(self, widget, event):
        '''Stop drawing rectangle. Prepare for a new drawing''' 
        if event.button == 1 and self.pixmap != None:
            #print "release_event"
            self.is_drawing=False
            width, height = event.window.get_size()
            self.pixmap.draw_pixbuf(self.gc, self.pbd, 0, 0, 0, 0, width, height)
            self.drawing_area.queue_draw_area(0, 0, width, height)
            self.window.hide()
            self.window.destroy()
            #self.rect2watch=None
            x = event.x
            y = event.y
            self.x=int(x)
            self.y=int(y)
            self.is_choosing = False
        return True

    def motion_notify_event(self, widget, event):
        #self.fill_window(widget,event)
        if self.is_choosing == False:
            return
        #print "motion event"
        if event.is_hint:
            x, y, state = event.window.get_pointer()
        else:
            x = event.x
            y = event.y
            state = event.state
        x=int(x)
        y=int(y)
        if state & gtk.gdk.BUTTON1_MASK and self.pixmap != None:
            #self restore old area, and save a new one (Non optimal but OK for now)
            self.draw_brush(widget, self.start_x, self.start_y, x, y, widget.get_style().black_gc, False)
            pass
        return True
    
    # Returns selected area coordinates (left_x, top_y, sz_x, sz_y)    
    def get_rectangle(self):
        #print self.start_x, self.start_y, self.x, self.y
        area = (min(self.start_x, self.x), min(self.start_y, self.y), max(self.start_x, self.x), max(self.start_y, self.y))
        rect = (area[0], area[1], area[2]-area[0], area[3]-area[1])#x,y,sz_x,sz_y
        return rect
        
def main():
    sb=SelectArea()
    return 0

if __name__ == "__main__":
    main()

